package edu.cmu.cs.able.gauges.Siena.Demo;

import java.util.*;

public class ProbeMessageUtil {

  final static String prefix = "Probe Message:";  
  
  private static synchronized String genDate() {
      
      //generate a timestamp for the message
      try {
        Thread.currentThread().sleep(10);
      }catch (InterruptedException e) {}
      long time = System.currentTimeMillis();      
      return "(" + time + ")";
  }
  
  public synchronized static String composeMessage(String messageType, String msg) {
  	
  	 String s = prefix + genDate() + messageType +"@" + msg;        
  	 
  	 return s;
  }
  
  public static boolean isProbeMessage(String msg) {
      if (msg == null|| msg.length() < prefix.length()) return false;
      return prefix.equals(msg.substring(0, prefix.length()));
  }  
  
  public static String skipPrefix(String msg) {
      
      return msg.substring(prefix.length());
  } 
      
  public static long getTimestamp(String msg) {
      
      int   st = msg.indexOf('(');
      int   ed = msg.indexOf(')');
      
      long timeStamp = Long.parseLong(msg.substring(st + 1, ed));

      return  timeStamp;
  }
  
  public static String skipTimestamp(String msg) {
      
      int   ed = msg.indexOf(')');
      return msg.substring(ed + 1);
  }  
  
  public static String  getComponentName(String msg) {
      
      int   st = msg.indexOf('@');            
      return msg.substring(0, st);      
  }
  
  public static String skipComponentName(String msg) {
      
      int   ed = msg.indexOf('@');
      return msg.substring(ed + 1);
  }  
}